
Foreman - Refactor #28620

db:migrate fails with SQLite on Rails 6

01/02/2020 08:36 PM - Anonymous

Status: Closed   

Priority: Normal   

Assignee: Ondřej Ezr   

Category: DB migrations   

Target version:    

Difficulty:  Fixed in Releases: 2.1.0

Triaged: No Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/7552

  

Description

== 20140910153654 MoveHostNicsToInterfaces: migrating =========================

-- add_column(:nics, :primary, :boolean, {:default=>false})

   -> 0.0015s

-- add_column(:nics, :provision, :boolean, {:default=>false})

   -> 0.0012s

-- Migrating Host interfaces to standalone Interfaces

-- remove_column(:hosts, :ip)

   -> 0.0594s

-- remove_column(:hosts, :mac)

   -> 0.0626s

-- remove_column(:hosts, :primary_interface)

   -> 0.0668s

-- remove_foreign_key(:hosts, {:name=>"hosts_subnet_id_fk"})

rake aborted!

StandardError: An error has occurred, this and all later migrations canceled:

Table 'hosts' has no foreign key for {}

/home/mmoll/mystuff/gitrepos/theforeman/foreman/vendor/ruby/2.7.0/gems/activerecord-6.0.2.1/lib/ac

tive_record/connection_adapters/sqlite3/schema_statements.rb:75:in `remove_foreign_key'

/home/mmoll/mystuff/gitrepos/theforeman/foreman/vendor/ruby/2.7.0/gems/activerecord-6.0.2.1/lib/ac

tive_record/migration.rb:890:in `block in method_missing'

/home/mmoll/mystuff/gitrepos/theforeman/foreman/vendor/ruby/2.7.0/gems/activerecord-6.0.2.1/lib/ac

tive_record/migration.rb:858:in `block in say_with_time'

/home/mmoll/mystuff/gitrepos/theforeman/foreman/vendor/ruby/2.7.0/gems/activerecord-6.0.2.1/lib/ac

tive_record/migration.rb:858:in `say_with_time'

/home/mmoll/mystuff/gitrepos/theforeman/foreman/vendor/ruby/2.7.0/gems/activerecord-6.0.2.1/lib/ac

tive_record/migration.rb:879:in `method_missing'

/home/mmoll/mystuff/gitrepos/theforeman/foreman/db/migrate/20140910153654_move_host_nics_to_interf

aces.rb:42:in `up'

 Probably related to https://blog.bigbinary.com/2019/09/24/rails-6-adds-add_foreign_key-and-remove_foreign_key-for-sqlite3.html

Related issues:

Blocks Foreman - Tracker #24837: Rails 6.0 Tracker Closed

Associated revisions

Revision a13f48bb - 04/05/2020 10:01 AM - Ondřej Ezr

Fixes #28620 - sqlite foreign_key removal

History

#1 - 01/02/2020 08:36 PM - Anonymous

- Blocks Tracker #24837: Rails 6.0 Tracker added
https://blog.bigbinary.com/2019/09/24/rails-6-adds-add_foreign_key-and-remove_foreign_key-for-sqlite3.html


#2 - 03/30/2020 02:55 PM - Tomer Brisker

- Assignee set to Ondřej Ezr

#3 - 03/30/2020 11:43 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/7552 added

#4 - 04/06/2020 03:01 AM - Ondřej Ezr

- Status changed from Ready For Testing to Closed

Applied in changeset a13f48bb25d4f1c039d5ae292f6da570b2d6ede3.

#5 - 05/17/2020 01:54 PM - Tomer Brisker

- Fixed in Releases 2.1.0 added
